Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.plaf.basic
Class BasicLookAndFeel

    java.lang.Object
      |
      +--javax.swing.LookAndFeel
            |
            +--javax.swing.plaf.basic.BasicLookAndFeel

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  MetalLookAndFeel

public abstract class BasicLookAndFeel
extends LookAndFeel
implements Serializable

Implements the a standard base LookAndFeel class from which standard desktop LookAndFeel classes (JLF, Mac, Windows, etc.) can be derived. This class cannot be instantiated directly, however the UI classes "Basic" defines can be.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeansTM has been added to the `java.beans` package. Please see `XMLEncoder`.

Constructor Summary
`BasicLookAndFeel()`

Method Summary
`protected Action` | `createAudioAction(Object key)` Returns an `Action`.
`protected ActionMap` | `getAudioActionMap()` Returns an `ActionMap`.
`UIDefaults` | `getDefaults()` This method is called once by UIManager.setLookAndFeel to create the look and feel specific defaults table.
`protected void` | `initClassDefaults(UIDefaults table)` Initialize the uiClassID to BasicComponentUI mapping.
`protected void` | `initComponentDefaults(UIDefaults table)`
`protected void` | `initSystemColorDefaults(UIDefaults table)` Load the SystemColors into the defaults table.
`protected void` | `loadSystemColors(UIDefaults table, String[] systemColors, boolean useNative)` If this is the native look and feel the initial values for the system color properties are the same as the SystemColor constants.
`protected void` | `playSound(Action audioAction)` Decides whether to fire the `Action` that is passed into it and, if needed, fires the `Action`'s `actionPerformed` method.

Methods inherited from class javax.swing.LookAndFeel
`getDescription, getDesktopPropertyValue, getID, getName, getSupportsWindowDecorations, initialize, installBorder, installColors, installColorsAndFont, isNativeLookAndFeel, isSupportedLookAndFeel, loadKeyBindings, makeComponentInputMap, makeIcon, makeInputMap, makeKeyBindings, provideErrorFeedback, toString, uninitialize, uninstallBorder`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### BasicLookAndFeel

    public BasicLookAndFeel()

Method Detail

### getDefaults

    public UIDefaults getDefaults()

  Description copied from class: `LookAndFeel`
  This method is called once by UIManager.setLookAndFeel to create the look and feel specific defaults table. Other applications, for example an application builder, may also call this method.

  Overrides:
    `getDefaults` in class `LookAndFeel`
  See Also:
    `LookAndFeel.initialize()`, `LookAndFeel.uninitialize()`, `UIManager.setLookAndFeel(javax.swing.LookAndFeel)`

### initClassDefaults

    protected void initClassDefaults(UIDefaults table)

  Initialize the uiClassID to BasicComponentUI mapping. The JComponent classes define their own uiClassID constants (see AbstractComponent.getUIClassID). This table must map those constants to a BasicComponentUI class of the appropriate type.

  See Also:
    `getDefaults()`

### initSystemColorDefaults

    protected void initSystemColorDefaults(UIDefaults table)

  Load the SystemColors into the defaults table. The keys for SystemColor defaults are the same as the names of the public fields in SystemColor. If the table is being created on a native Windows platform we use the SystemColor values, otherwise we create color objects whose values match the defaults Windows95 colors.

### loadSystemColors

    protected void loadSystemColors(UIDefaults table,
                                    String[] systemColors,
                                    boolean useNative)

  If this is the native look and feel the initial values for the system color properties are the same as the SystemColor constants. If not we use the integer color values in the `systemColors` argument.

### initComponentDefaults

    protected void initComponentDefaults(UIDefaults table)

### getAudioActionMap

    protected ActionMap getAudioActionMap()

  Returns an `ActionMap`.

  This `ActionMap` contains `Actions` that embody the ability to render an auditory cue. These auditory cues map onto user and system activities that may be useful for an end user to know about (such as a dialog box appearing).

  At the appropriate time in a `JComponent` UI's lifecycle, the ComponentUI is responsible for getting the appropriate `Action` out of the `ActionMap` and passing it on to `playSound`.

  The `Actions` in this `ActionMap` are created by the `createAudioAction` method.

  Returns:
    an ActionMap containing Actions responsible for rendering auditory cues
  Since:
    1.4
See Also:
  `createAudioAction(java.lang.Object)`, `playSound(Action)`

### createAudioAction

    protected Action createAudioAction(Object key)

  Returns an `Action`.

  This Action contains the information and logic to render an auditory cue. The `Object` that is passed to this method contains the information needed to render the auditory cue. Normally, this `Object` is a `String` that points to an audio file relative to the current package. This `Action`'s `actionPerformed` method is fired by the `playSound` method.

  Returns:
    an Action which knows how to render the auditory cue for one particular system or user activity
  Since:
    1.4
See Also:
  `playSound(Action)`

### playSound

    protected void playSound(Action audioAction)

  Decides whether to fire the `Action` that is passed into it and, if needed, fires the `Action`'s `actionPerformed` method. This has the effect of rendering the audio appropriate for the situation.

  The set of possible cues to be played are stored in the default table value "AuditoryCues.cueList". The cues that will be played are stored in "AuditoryCues.playList".

  Parameters:
    `audioAction` - an Action that knows how to render the audio associated with the system or user activity that is occurring
  Since:
    1.4

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.